{ config, lib, pkgs, ... }:

{

  networking.interfaces.eth0 = {
    genode.driver = "virtio";
    useDHCP = true;
  };

  services.tor = {
    enable = true;
    client.enable = false;
    extraConfig = ''
      Log [general,net,config,fs]debug stdout
    '';
    relay = {
      enable = true;
      port = 80;
      role = "relay";
      bridgeTransports = [ ];
    };
  };

  systemd.services.tor.genode = {
    enable = true;
    interface = "eth0";
    ramQuota = 1024;
    extraVfs = pkgs.writeText "tor.vfs.dhall" ''
      let VFS = (env:DHALL_GENODE).VFS

      in  [ VFS.dir "var" [ VFS.dir "lib" [ VFS.leaf "ram" ] ] ]
    '';
  };

}
